<?php
	// import

	require_once 'generic_db.inc.php';
	require_once 'db_pattern.inc.php';


	/**
	 * Database wrapper for table "dynpg_cms_article".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DB_DynPGDB_Article extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_article';

		// constructor

			function DB_DynPGDB_Article() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id, $byAutoDelete = false, $deleteContent = false) {
                if ($deleteContent || $byAutoDelete) {
                    $dbh = new DB_DynPGDB_Article();
                    $dbh->readRow($id);
                    $row = $dbh->db_fetch_row();
                }

				// delete article
                    $this->db_delete($id);

                // if $byAutoDelete, then
                // check, if more data has to be deleted
                    if ($byAutoDelete && $row['AUTO_DELETE'] != null) {
                        if ($row['AUTO_DELETE'] == 2 || $row['AUTO_DELETE'] == 4) {
                            // delete article text
                            if ($row['CONTENT'] > 0)
                                $this->db_execute("DELETE FROM `dynpg_cms_articletexts` WHERE `id` = '".mysql_real_escape_string($row['CONTENT'])."'");
                        }
                        if ($row['AUTO_DELETE'] == 3 || $row['AUTO_DELETE'] == 4) {
                            // delete lead image
                            $dbh->db_setQuery("SELECT * FROM `dynpg_cms_leadimages` WHERE `AID` = '".mysql_real_escape_string($id)."'");
                            while ($li = $dbh->db_fetch_row()) {
                                $this->db_execute("DELETE FROM `dynpg_cms_images` WHERE `IID` = '".mysql_real_escape_string($id)."'");
                            }
                            $this->db_execute("DELETE FROM `dynpg_cms_leadimages` WHERE `AID` = '".mysql_real_escape_string($id)."'");
                        }
                        return;
                    }

                // try to delete content
                if ($deleteContent && $row['CONTENT'] > 0)
                    $this->db_execute("DELETE FROM `dynpg_cms_articletexts` WHERE `id` = '".mysql_real_escape_string($row['CONTENT'])."'");
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				// insert article
					$group = $row[array_search('GROUP', $this->tbl_container[$this->db_table]['rows'])];
					$user = $row[array_search('OWNER', $this->tbl_container[$this->db_table]['rows'])];

					$this->db_insert($row);
					$article_id = mysql_insert_id();

				// insert right
		            $dbh = new DB_DynPGDB_Rights();
		            $dbh->insert(
		                Array(
		                    $user,
		                    'ARTICLE',
		                    $article_id,
		                    'TRUE',
		                    'TRUE',
		                    'TRUE',
		                    (dynpg_getRightsToUser(C_RIGHTS_PUBLISH, 'GROUP', $group)?'TRUE':'FALSE')
		                )
		            );

                if (!dynpg_getRightsToUser(C_RIGHTS_AUTARKIC)) {
					$_ = mysql_query("SELECT DISTINCT A.*, B.`CREATE`, B.`DELETE`, B.`CHANGE`, B.`PUBLISH` FROM `dynpg_cms_user` AS A INNER JOIN `dynpg_cms_rights` AS B ON A.`id` = B.`USERID` WHERE B.`PARENT` = 'GROUP' AND B.`SECTION` = '".mysql_real_escape_string($group)."' AND ( B.`CREATE` = 'TRUE' OR B.`CHANGE` = 'TRUE' OR B.`DELETE` = 'TRUE' )");
					while($r = mysql_fetch_assoc($_)){
						if ($r['id'] != $user) {
							$dbh->insert(
				                Array(
				                    $r['id'],
				                    'ARTICLE',
				                    $article_id,
				                    'TRUE',
				                    $r['DELETE'],
				                    $r['CHANGE'],
				                    $r['PUBLISH']
				                )
				            );
						}
					}
					@mysql_free_result($_);
                }

                return $article_id;
			}


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
                if (!empty($row['TEXT'])) {
                    $this->readRow($id);
                    $item = $this->db_fetch_row();
                    $cnt_idx = (integer)$item['CONTENT'];

                    $dbh = new DB_DynPGDB_ArticleTexts();
                    if ($cnt_idx <= 0) {
                        $dbh->insert(Array($row['TEXT'], 0));
                        $cnt_idx = mysql_insert_id();
                    } else {
                        $dbh->update(Array('TEXT' => $row['TEXT']), $cnt_idx);
                    }
                    $row['CONTENT'] = $cnt_idx;
                    unset($row['TEXT']);
                }
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `id` = '".mysql_real_escape_string($id)."'");
			}

			// Read a single row.
			function readAll() {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1");
			}

			// Read last modified article
			function readLastModified($limit = 10, $orderby = 'CHANGED', $sort = 'DESC') {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1 ORDER BY CHANGED DESC");
			}

			// Read last modified article
			function readDeleteQueue($limit = 50, $orderby = 'CHANGED', $sort = 'DESC') {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `AUTO_DELETE` IS NOT NULL AND `DATE_TO` != '0000-00-00' AND UNIX_TIMESTAMP(`DATE_TO`) <= UNIX_TIMESTAMP() ORDER BY `DATE_TO` ASC, `TIME_TO` ASC");
			}

			// Read by group
			function readRowByGroup($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `GROUP` = '".mysql_real_escape_string($id)."'");
			}
	}


	/**
	 * Database wrapper for table "dynpg_cms_articletexts".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DB_DynPGDB_ArticleTexts extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_articletexts';

		// constructor

			function DB_DynPGDB_ArticleTexts() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id) {
                $this->db_delete($id);
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				$this->db_insert($row);
				return mysql_insert_id();
            }


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `id` = '".mysql_real_escape_string($id)."'");
			}

			// Read a single row.
			function readAll() {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1");
			}
	}


	/**
	 * Database wrapper for table "dynpg_cms_articletexts".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DB_DynPGDB_Groups extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_groups';

		// constructor

			function DB_DynPGDB_Groups() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// helping methods
			function getDirectParent($_Child = null) {
		    	if ($_Child == null) {
		    		return null;
		    	}

		    	if ( mysql_num_rows(mysql_query("SELECT * FROM `dynpg_cms_group_treestruct` WHERE `element_id_fk` = '".mysql_real_escape_string($_Child)."' AND `root_id_fk` IS NULL GROUP BY `element_id_fk`")) > 0 ) {
		    		return null;
		    	}

		    	extract(mysql_fetch_assoc(mysql_query("SELECT `element_id_fk` FROM `dynpg_cms_group_treestruct` WHERE `successor_id_fk` = '".mysql_real_escape_string($_Child)."' GROUP BY `element_id_fk`")));

		    	return isset($element_id_fk)? $element_id_fk: null;
		    }

		    function recursive_Delete_Subgroups($_grp_id = NULL) {
		        if ( is_null($_grp_id) ) {
		            return 0;
		        }

		        $mysql_result = mysql_query("SELECT * FROM `dynpg_cms_group_treestruct` WHERE `element_id_fk` = '".mysql_real_escape_string($_grp_id)."'");

		        while ( $mysql_row = mysql_fetch_assoc($mysql_result) ) {
		            // group has successors
		            $this->recursive_Delete_Subgroups($mysql_row['successor_id_fk']);
		        }

		        mysql_query("DELETE FROM `dynpg_cms_groups` WHERE `id` = '".mysql_real_escape_string($_grp_id)."'");
		        mysql_query("DELETE FROM `dynpg_cms_group_treestruct` WHERE `successor_id_fk` = '".mysql_real_escape_string($_grp_id)."' AND `root_id_fk` IS NOT NULL");
		        mysql_query("UPDATE `dynpg_cms_group_treestruct` SET `successor_id_fk` = NULL WHERE `successor_id_fk` = '".mysql_real_escape_string($_grp_id)."' AND `root_id_fk` IS NULL");

		        mysql_query("DELETE FROM `dynpg_cms_article` WHERE `GROUP` = '".mysql_real_escape_string($_grp_id)."'");
		        mysql_query("DELETE FROM `dynpg_cms_rights` WHERE `PARENT` = 'GROUP' AND `SECTION` = '".mysql_real_escape_string($_grp_id)."'");

		        return 0;
		    }


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id, $delete_refid = false) {
                mysql_query("DELETE FROM `dynpg_cms_rights` WHERE `PARENT`='GROUP' AND `SECTION`='".mysql_real_escape_string($id)."'");

                if ($delete_refid) {
                    $group = mysql_fetch_assoc(mysql_query("SELECT `REFID` FROM `dynpg_cms_groups` WHERE `id` = '".mysql_real_escape_string($id)."'"));
                    if (!empty($group['REFID'])) {
                        $dbh = new DB_DynPGDB_Article();
                        $dbh->delete($group['REFID']);
                    }
                }

				$parent = $this->getDirectParent($id);

				$this->recursive_Delete_Subgroups($id);

				if (!is_null($parent)) {
					if (mysql_num_rows(mysql_query("SELECT * FROM `dynpg_cms_group_treestruct` WHERE `element_id_fk` = '".mysql_real_escape_string($parent)."' AND `root_id_fk` IS NULL")) > 1)
						mysql_query("DELETE FROM `dynpg_cms_group_treestruct` WHERE `successor_id_fk` IS NULL AND `element_id_fk` = '".mysql_real_escape_string($parent)."' AND `root_id_fk` IS NULL");
				}

		        mysql_query("DELETE FROM `dynpg_cms_group_treestruct` WHERE `successor_id_fk` = '".mysql_real_escape_string($id)."' AND `root_id_fk` IS NOT NULL");
		        mysql_query("DELETE FROM `dynpg_cms_group_treestruct` WHERE `successor_id_fk` IS NULL AND `element_id_fk` = '".mysql_real_escape_string($id)."' AND `root_id_fk` IS NULL");
		        mysql_query("UPDATE `dynpg_cms_group_treestruct` SET `successor_id_fk` = NULL WHERE `successor_id_fk` = '".mysql_real_escape_string($id)."' AND `root_id_fk` IS NULL");

				return true;
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				$this->db_insert($row);
				$group_id = mysql_insert_id();
				return $group_id;
			}


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `id` = '".mysql_real_escape_string($id)."'");
			}

			// Read a single row.
			function readAll() {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1");
			}
	}


	/**
	 * Database wrapper for table "dynpg_cms_rights".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DB_DynPGDB_Rights extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_rights';

		// constructor

			function DB_DynPGDB_Rights() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id) {
                $this->db_delete($id);
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				$this->db_insert($row);
				return mysql_insert_id();
            }


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `id` = '".mysql_real_escape_string($id)."'");
			}

			// Read a single row.
			function readAll() {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1");
			}
	}


	/**
	 * Database wrapper for table "dynpg_cms_article_options".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DB_DynPGDB_Article_Options extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_article_options';

		// constructor

			function DB_DynPGDB_Article_Options() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id) {
                $this->db_delete(null, "`option_id_fk` = '".mysql_real_escape_string($id)."'");
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				$this->db_insert($row);
            }


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `article_id_fk` = '".mysql_real_escape_string($id)."'");
			}

			// Read a single row.
			function readAllActive() {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE 1 ORDER BY `article_id_fk` ASC");
			}

			// Read a single row.
			function readAll($lang = 'de') {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}_lang` WHERE `language` = '".mysql_real_escape_string($lang)."' ORDER BY `description` ASC");
			}
	}


	/**
	 * Database wrapper for table "dynpg_cms_plugin_rights".
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2011
	 * @access public
	 */
	class DB_DynPGDB_Plugin_Rights extends DBDynPGDatabaseHandle {

		// sets table for this strickle-class
		var $db_table = 'dynpg_cms_plugin_rights';

		// constructor

			function DB_DynPGDB_Plugin_Rights() {
				// call parent constructor of class DBMyPluginHandle
				$this->DBDynPGDatabaseHandle();
			}


		// executing methods

			// procedure delete: x integer
			// Simply deletes a row by using Generic_DB::db_delete() only.
			function delete($id) {
                $this->db_delete(null, "`user_id_fk` = '".mysql_real_escape_string($id)."'");
			}


			// procedure insert
			// Simply inserts a row by using Generic_DB::db_insert() only.
			function insert($row) {
				$this->db_insert($row);
            }


			// procedure update: x array, x integer
			// Simply updated a row by using Generic_DB::db_update() only.
			function update($row, $id) {
				$this->db_update($row, $id);
			}


			// procedure dublicate
			// Currently not implemented. Probably not nessecary.
			function dublicate() {
				return;
			}


		// sql query methods

			// Read a single row.
			function readRow($id, $plugin) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `user_id_fk` = '".mysql_real_escape_string($id)."' AND `plugin` = '".mysql_real_escape_string($plugin)."'");
			}

			// Read a single row.
			function readAll($user_id) {
				$this->db_setQuery("SELECT * FROM `{$this->db_table}` WHERE `user_id_fk` = '".mysql_real_escape_string($user_id)."'");
			}
	}
?>